/*
 * In dieser Datei sind alle Routinen versammelt, die etwas mit der
 * Anzeige innerhalb des Windows zu tun haben. Dazu gehoehren
 * Hintergrund, Schaltflaechen, Hinweise und das Spielfeld.
 */

#include	"xmik.h"
#include	<string.h>
#include	<unistd.h>

extern Display		*xdsp;
extern Window		xwin;
extern Window		xnf, xnj, xnn;
extern Cursor		xc1, xc3;
extern Colormap		xcm;
extern unsigned long	xbp;
extern GC		xgc;
extern char		befehl[BEFLEN];
extern char		hilfestr[BEFLEN];
extern Pixmap		xp1, xp2;
extern XFontStruct	*xfi;
extern unsigned long	xwp;

extern char		bildname[2][6][6][50];
extern struct tip	hinweis[2][39];
extern int		hinschalter;
extern char		feld[3][6][6][6];
extern int		spielnummer;
extern char		nurpos;
extern long int		zeit;
extern char 		zeitstr[20];

extern char		gesetzt(int f, int z, int s);
extern int		zahlwert(char *ziffern);
extern int		zufall(int von, int bis);
extern char		*zeitdarstellung(void);

/*
 * Da nur hier mit Farben gearbeitet wird, kann auch hier die Struktur
 * zur Speicherung der diversen Farben festgelegt werden.
 */
struct farbe{
  char farbzeichen;
  char farbname[30];
  unsigned long wert;};

/*
 * Es gibt offenbar Probleme bei der Zusammenarbeit von den Routinen
 * `putpix' und `information', daher wird eine globale Routine
 * eingefuehrt, die die gleichzeitige Bearbeitung dieser beiden
 * Routinen verhindert.
 */
char laeuftputpix=False;

/* Zuerst erfolgt die Realisierung eines Unterprogramms, das von
 * verschiedenen Seiten verwendet wird. Es dient dazu eine Pixmap, die
 * in einem File abgelegt ist, auf die Windowoberflaeche zu bekommen.
 * Die Routine ist ebenfalls aeusserst robust ausgelegt, um moegliche
 * Fehler zwar im Aussehen des Windows wiederzufinden, aber nicht zu
 * einem Abbruch der Routine zu fuehren.
 *
 * Da es so aussieht, als wenn das Programm immer in dieser Routine
 * abstuerzt, habe ich hier erheblich mit Debuggingdirektiven
 * gearbeitet, was den Code etwas schwer lesbar macht.
 */
void putpix(char *name, int x, int y, int b, int h){
  struct farbe	color[16]; /* Maximal 16 Farben werden unterstuetzt */
  FILE		*fp;
  char		io[1000], *test, *hilfe;
  int		breite, hoehe, farben, index;
  int		ab, ah, zeile, spalte;
  XColor	def, rgb;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Beginn von putpix\n");
fflush(NULL);
#endif

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Beginn von putpix\n");
fprintf(stderr,"putpix: Eingelesen wird: %s\n",name);
fflush(NULL);
#endif

  laeuftputpix=True;
  /*
   * Es ist sinnvoll hier erst einmal alle Events abzuarbeiten, da in
   * dieser Routine jede Menge von Aufrufen an die X-Library erfolgen
   * und die Queuelaenge ueberschritten werden kann.
   */
  XSync(xdsp, False);

  fp=fopen(name,"r");
  if (fp){

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: File geoeffnet\n");
fflush(NULL);
#endif

    do{
      test=fgets(io, 999, fp);}
    while ((test) && (io[0] != 34));

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Erste relevante Zeile im File gefunden\n");
fflush(NULL);
#endif

    farben=0; breite=0; hoehe=0;
    if (test){ /* Die bestimmende Zeile konnte gelesen werden. Nun
		* werden die Integerwerte bestimmt */
      test=&io[1]; while (*test==' ') test++;
      hilfe=test; while (*hilfe != ' ') hilfe++;
      *hilfe='\0';
      breite=zahlwert(test);
      *hilfe=' '; test=hilfe; while (*test == ' ') test++;
      hilfe=test; while (*hilfe != ' ') hilfe++;
      *hilfe='\0';
      hoehe=zahlwert(test);
      *hilfe=' '; test=hilfe; while (*test==' ') test++;
      hilfe=test; while (*hilfe!=' ') hilfe++;
      *hilfe='\0';
      farben=zahlwert(test);}

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Farben, Breite und Hoehe eingelesen\n");
fprintf(stderr,"putpix: F: %d, B: %d, H: %d\n",farben,breite,hoehe);
fflush(NULL);
#endif

    if (farben < 17){
      /* Nun koennen die Farbnamen und deren Zeichen eingelesen
       * werden */
      for (index=0; index<16; index++) color[index].wert=-1;
      for (index=0; index<farben; index++){
	do test=fgets(io,999,fp); while ((test) && (io[0]!=34));
	if (io[0]==34){
	  color[index].farbzeichen=io[1];
	  test=&io[2];
	  do test++; while (*test != 'c'); test++;
	  do test++; while (*test==' ');
	  hilfe=test; do hilfe++; while (*hilfe!=34);
	  *hilfe='\0';
	  strcpy(color[index].farbname, test);

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Farbname ist %s\n",test);
XFlush(xdsp);
fflush(NULL);
#endif

	  XAllocNamedColor(xdsp, xcm, color[index].farbname, &def, &rgb);
	  color[index].wert=def.pixel;}}}

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Farben eingelesen und alloziiert\n");
fflush(NULL);
#endif

       /* Nun sind die Farben alloziiert und die Pixel koennen im
	* Window gesetzt werden. Zuvor muss nur noch die tatsaechliche
	* Breite und Hoehe des Bildes festgestellt werden. */
       XSync(xdsp, False);
       if (b<breite) ab=b; else ab=breite;
       if (h<hoehe) ah=h; else ah=hoehe;
       for (zeile=0; zeile<ah; zeile++){
         do test=fgets(io,999,fp); while ((test) && (io[0]!=34));
         for (spalte=0; spalte<ab; spalte++){
	   index=0;
	   while (io[spalte+1] != color[index].farbzeichen) index++;
	   XSetForeground(xdsp, xgc, color[index].wert);
	   XDrawPoint(xdsp, xwin, xgc, x+spalte, y+zeile);
	 }
       }
    fclose(fp);}
    XSetForeground(xdsp, xgc, xbp);

    /*
     * Zur Sicherheit wird auch am Ende von putpix noch einmal der
     * Queue der X-Library `gereinigt'
     */
    XSync(xdsp, False);

    laeuftputpix=False;

#ifdef PUTPIXDEBUG
fprintf(stderr,"putpix: Ende von putpix\n");
fflush(NULL);
#endif

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von putpix\n");
fflush(NULL);
#endif
}
  
/*
 * Das `Nicht-Zeichen' kann in verschiedene Hinweise gezeichnet
 * werden, daher bietet sich ein Unterprogramm an. Uebergeben wird der
 * Mittelpunkt des Kreises.
 */
void nichtzeichen(int x, int y){
  XColor def, rgb;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von nichtzeichen\n");
fflush(NULL);
#endif
  XAllocNamedColor(xdsp, xcm, "red", &def, &rgb);
  XSetForeground(xdsp, xgc, def.pixel);
  XSetLineAttributes(xdsp, xgc, 5, LineSolid, CapNotLast, JoinRound);
  XDrawArc(xdsp, xwin, xgc, x-24, y-24, 48, 48, 0, 360*64);
  XDrawLine(xdsp, xwin, xgc, x-17, y+17, x+17, y-17);
  XSetForeground(xdsp, xgc, xbp);
  XSetLineAttributes(xdsp, xgc, 3, LineSolid, CapNotLast, JoinRound);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von nichtzeichen\n");
fflush(NULL);
#endif
}

/*
 * Die folgende Routine zeichnet ein Hinweisbild an die angegebene
 * Stelle. Uebergeben werden:
 * 1. Die Nummer des Hinweises
 * 2. Die Nummern des Zeichens innerhalb des Hinweises
 * 3. x-, und y-Position des Zeichens.
 * Die Groesse ist immer gleich.
 */
void zeichne(int hin, int z, int s, int x, int y){
  char name[100];
  int spalte, zeile;

  zeile=hinweis[hinschalter][hin].www[z]-'0';
  spalte=hinweis[hinschalter][hin].www[s]-'0';
  if ((spalte>=0) && (spalte<=5) && (zeile>=0) && (zeile<=5)){
    /* Gueltiger Hinweis */
    strcpy(name, BASENAME);
    strcat(name, bildname[0][zeile][spalte]);
    putpix(name, x, y, 48, 48);}}

/*
 * Nun erfolgt die erste `richtige' Routine.
 * Sie laedt den Hintergrund und plaziert ihn im Window.
 */
void hintergrund(void){
  XWindowAttributes xat;
  unsigned int	breite, hoehe;
  int		filelesen, spotx, spoty;
  char		name[100];

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von hintergrund\n");
fflush(NULL);
#endif

  strcpy(name,BASENAME);
  strcat(name,BACKNAME);
  filelesen=XReadBitmapFile(xdsp, xwin, name,
			    &breite, &hoehe, &xp1, &spotx,
			    &spoty);
  if ((filelesen==BitmapSuccess) && (xp1)){
    XGetWindowAttributes(xdsp, xwin, &xat);
    xp2=XCreatePixmap(xdsp, xwin, 10, 10, xat.depth);
    XCopyPlane(xdsp, xp1, xp2, xgc, 0, 0, 10, 10, 0, 0, 1);
    XSetWindowBackgroundPixmap(xdsp, xwin, xp2);
    XClearWindow(xdsp, xwin);
    XFreePixmap(xdsp, xp1);
    XFreePixmap(xdsp, xp2);}
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von hintergrund\n");
fflush(NULL);
#endif
}

/*
 * Die naechste Routine liest die Schaltflaechenpixmaps ein und
 * plaziert sie ebenfalls im Window.
 */
void schaltflaechen(void){
  char name[100];
  int rx, ry;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von schaltflaechen\n");
fflush(NULL);
#endif
  rx=6*(SKIP+FB)+SKIP; ry=7*(SKIP+HH);
  strcpy(name,BASENAME); strcat(name,ENDENAME);
  putpix(name, rx, ry, 3*HB, HH);
  ry=ry+HH;
  strcpy(name,BASENAME); strcat(name,HILFNAME);
  putpix(name, rx, ry, 3*HB, HH);
  ry=ry+HH;
  strcpy(name,BASENAME); strcat(name,ANDENAME);
  putpix(name, rx, ry, 3*HB, HH);
  ry=ry-2*HH; rx=rx+3*HB;
  strcpy(name,BASENAME); strcat(name,FEHLNAME);
  putpix(name, rx, ry, 3*HB, HH);
  ry=ry+HH;
  strcpy(name,BASENAME); strcat(name,BISFNAME);
  putpix(name, rx, ry, 3*HB, HH);
  ry=ry+HH;
  strcpy(name, BASENAME); strcat(name,WIEDNAME);
  putpix(name, rx, ry, 3*HB, HH);
  rx=rx+3*HB+SKIP; ry=ry-2*HH;
  strcpy(name, BASENAME); strcat(name, LOGONAME);
  putpix(name, rx, ry, 3*HB+SKIP, 3*HH);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von schaltflaechen\n");
fflush(NULL);
#endif
}

/*
 * Die Darstellung der Hinweise wird etwas geaendert. 18.9.1999
 *
 * In der folgenden Routine wird untersucht, ob der aktuelle Hinweis
 * etwas enthaelt und ob er sich vom entsprechenden in der Reserve
 * unterscheidet. In diesem Fall muss der Hinweis neu gezeichnet
 * werden.
 * Abschliessend wird der aktuelle Hinweis in die Reserve kopiert,
 * damit er beim naechsten Aufruf nicht wieder gezeichnet wird.
 */
char isterneu(int nr){
  char ergebnis, relevant, neu;
  int j;

  /* Test auf Relevanz des Hinweises */
  relevant=False;
  if (hinweis[hinschalter][nr].typ) relevant=True;
  if (!relevant){
    for (j=0; j<6; j++){
      hinweis[hinschalter][nr].www[j]=' ';}}
  
  /* Nun der Vergleich der Hinweise */
  neu=False;
  if (hinweis[hinschalter][nr].typ != hinweis[2][nr].typ) neu=True;
  for (j=0; j<6; j++){
    if (hinweis[hinschalter][nr].www[j] != hinweis[2][nr].www[j])
    neu=True;}

  /* Das Ergebnis wird festgelegt */
  ergebnis=relevant && neu;

  /* Und nun der Hinweis in die Reserve kopiert */
  hinweis[2][nr].typ=hinweis[hinschalter][nr].typ;
  for (j=0; j<6; j++){
    hinweis[2][nr].www[j]=hinweis[hinschalter][nr].www[j];}

  /* Und das Ergebnis zurueckgegeben */
  return(ergebnis);}

/*
 * Nun kommt die Darstellung der Hinweise der ersten Art, das sind
 * diejenigen, die am unteren Bildrand dargestellt werden und die aus
 * zwei Bildern bestehen.
 */
void untenhinw(void){
  int i, xval, yval, rx, ry;

#ifdef XDEBG
fprintf(stderr,"Anfang von untenhinw\n");
fflush(NULL);
#endif
  for (i=0; i<18; i++){
    xval=(int)(i % 9);
    yval=(int)(i / 9);
    rx=SKIP+xval*HB;
    ry=6*(SKIP+HH)+SKIP+yval*(2*HH+SKIP);
    if (hinweis[hinschalter][i].typ==0){
      /* Leeren des alten Inhalts */
      XClearArea(xdsp, xwin, rx, ry, HB, 2*HH, False);
      XDrawRectangle(xdsp, xwin, xgc, rx, ry, HB, 2*HH);}
    if (isterneu(i)){
      /* Es muss tatsaechlich was gezeichnet werden. Jeder Hinweis
       * dieser Art besteht aus zwei Bildern. Nach dem Zeichnen der
       * Bilder muss noch geprueft werden, welcherHinweistyp es
       * tatsaechlich ist, da eventuell noch der Kreis gezeichnet
       * werden muss. */
      XDrawRectangle(xdsp, xwin, xgc, rx, ry, HB, 2*HH);
      zeichne(i, 0, 1, rx, ry);
      zeichne(i, 2, 3, rx, ry+HH);
      if (hinweis[hinschalter][i].typ==2)
        /* Beim Typ 2 muss noch das `Nicht'-Zeichen gezeichnet werden.
	 * Dieses wird auf das Window gemalt. */
	nichtzeichen(rx+(int)(HB/2)-1, ry+HH);
      }}
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von untenhinw\n");
fflush(NULL);
#endif
}

/*
 * Nun folgt die Routine, die die Hinweise am rechten Bildrand
 * zeichnet. Hier ist die Arbeit etwas komplizierter, als bei den
 * unteren Hinweisen, da die Anordnung der Hinweise komplizierter ist.
 * Es werden einige lokale Variablen eingefuehrt, die als Hilfe
 * dienen.
 */
void seitenhinw(void){
  int i, index, xval, yval, rx, ry;
  char name[100];
  XColor def, rgb;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von seitenhinw\n");
fflush(NULL);
#endif
  for (i=18; i<39; i++){
    index=i-18;
    yval=index % 7;
    xval=(int)(index / 7);
    rx=6*(SKIP+FB)+SKIP+xval*(3*HB+SKIP);
    ry=SKIP+yval*HH;
    if (hinweis[hinschalter][i].typ==0){
      /* Loeschen des alten Inhalts */
      XClearArea(xdsp, xwin, rx, ry, 3*HB, HH, False);
      XDrawRectangle(xdsp, xwin, xgc, rx, ry, 3*HB, HH);}
    if (isterneu(i)){
      /* Es muss tatsaechlich was gemalt werden */
      XDrawRectangle(xdsp, xwin, xgc, rx, ry, 3*HB, HH);
      if (hinweis[hinschalter][i].typ==5){
        /* Besondere Zeichnung, da hier in der Mitte keins der
	   normalen Bilder steht. */
	zeichne(i, 0, 1, rx, ry);
	zeichne(i, 2, 3, rx+2*HB, ry);
	strcpy(name, BASENAME);
	strcat(name, RELINAME);
	putpix(name, rx+HB, ry, HB-2, HH-2);}
      else{
        zeichne(i, 0, 1, rx, ry);
	zeichne(i, 2, 3, rx+HB, ry);
	zeichne(i, 4, 5, rx+2*HB, ry);}
      if ((hinweis[hinschalter][i].typ==4) ||
          (hinweis[hinschalter][i].typ==7))
        nichtzeichen(rx+HH+(int)(HB / 2)-1, ry+(int)(HH / 2));
      if ((hinweis[hinschalter][i].typ==6) ||
          (hinweis[hinschalter][i].typ==7)){
	/* Bei diesen beiden Hinweisen muss noch ein Pfeil gemalt
	 * werden, hierzu werden die Werte von rx und ry neu besetzt. */
	rx=rx+(int)(HB / 2);
	ry=ry+(int)(HH / 2);
	XAllocNamedColor(xdsp, xcm, "red", &def, &rgb);
	XSetForeground(xdsp, xgc, def.pixel);
        XSetLineAttributes(xdsp, xgc, 5, LineSolid, CapNotLast, JoinRound);
	XDrawLine(xdsp, xwin, xgc, rx, ry, rx+2*HB, ry);
	XDrawLine(xdsp, xwin, xgc, rx, ry, rx+(int)(HB / 4), ry-(int)(HH / 4));
	XDrawLine(xdsp, xwin, xgc, rx, ry, rx+(int)(HB / 4), ry+(int)(HH / 4));
	rx=rx+2*HB;
	XDrawLine(xdsp, xwin, xgc, rx, ry, rx-(int)(HB / 4), ry-(int)(HH / 4));
	XDrawLine(xdsp, xwin, xgc, rx, ry,
	          rx-(int)(HB / 4), ry+(int)(HH / 4));
	XSetForeground(xdsp, xgc, xbp);
	XSetLineAttributes(xdsp, xgc, 3, LineSolid, CapNotLast, JoinRound);}}}
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von seitenhinw\n");
fflush(NULL);
#endif
}

/*
 * Die folgende Routine ist die komplexeste der Anzeigeroutinen, da
 * sie das Spielfeld anzeigt.
 * Hier muss unterschieden werden, ob ein Spielfeld schon gesetzt ist,
 * oder ob noch mehrere Moeglichkeiten gegeben sind. Je nach Ergebnis
 * der Untersuchung werden unterschiedliche Inhalte dargestellt.
 */
void zeichnefeld(int z, int s){
  int i, k, l, rx, ry;
  char zeichen, name[100];

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von zeichnefeld\n");
fflush(NULL);
#endif
    rx=SKIP+s*(FB+SKIP);
    ry=SKIP+z*(HH+SKIP);
    /* Leeren des alten Inhalts */
    XClearArea(xdsp, xwin, rx, ry, FB, HH, False);
    XDrawRectangle(xdsp, xwin, xgc, rx, ry, FB, HH);
    zeichen=gesetzt(1, z, s);
    if (zeichen){
      /* Ein bestimmtes Zeichen wurde gesetzt. Dieses Zeichen wird
       * nun einfach im Feld dargestellt. */
      strcpy(name, BASENAME);
      strcat(name, bildname[0][z][(int)zeichen-(int)'0']);
      putpix(name, rx+(int)(FB / 6), ry, HB-2, HH-2);}
    else{
      for (i=0; i<6; i++){
        zeichen=feld[1][z][s][i];
        if (zeichen != ' '){
          k=i % 3;
          l=(int)(i / 3);
          strcpy(name, BASENAME);
          strcat(name, bildname[1][z][(int)zeichen-(int)'0']);
          putpix(name, rx+k*(int)(FB/3), ry+l*(int)(HH/2),
                 (int)(FB/3), (int)(HH/2));}}}
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von zeichnefeld\n");
fflush(NULL);
#endif
}

void felddarstellung(void){
  int z, s;

  for (z=0; z<6; z++){
    for (s=0; s<6; s++){
      zeichnefeld(z, s);}}
}

/*
 * Zum Abschluss kommt die Routine, die den gesamten Windowinhalt
 * zeichnet.
 */
void windowinhalt(void){
  hintergrund();
  schaltflaechen();
  untenhinw();
  seitenhinw();
  felddarstellung();}

/*
 * Die letzte Routine zeigt einen Hilfestring auf dem Bildschirm an.
 * Waehrend des Spiels wird die Hilfe nicht ausgefuehrt, sondern
 * interpretiert und das Ergebnis auf dem Bildschrm angezeigt.
 *
 * Dabei werden bei einem positiven Befehl die entsprechenden Felder
 * gruen, bei einem negativen, die Felder rot umrandet. Dies gilt
 * sowohl fuer die Felder, als auch fuer den beteiligten Hinweis.
 */
void hilfeanzeigen(char *string, char flag){
  int zeile, spalte, bild, hinnr;
  XColor def, rgb;
  int xpf, ypf, brf, hof, xph, yph, brh, hoh;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von hilfeanzeigen\n");
fflush(NULL);
#endif
  zeile=hilfestr[1]-'0';
  spalte=hilfestr[2]-'0';
  bild=hilfestr[3]-'0';
  hinnr=zahlwert(&hilfestr[7]);
  if (strlen(hilfestr) < 8) hinnr=-1;
  xph=yph=brh=hoh=0;

  /* Die Werte innerhalb des Feldes */
  xpf=SKIP+spalte*(FB+SKIP)+(bild % 3)*((int)(FB / 3));
  ypf=SKIP+zeile*(HH+SKIP)+((int)(bild / 3))*((int)(HH /2 ));
  brf=(int)(FB / 3);
  hof=(int)(HH / 2);

  /* Die Werte im Hinweis */
  if (hinnr > 17){
    xph=6*(SKIP+FB)+SKIP+((int)((hinnr-18)/7))*(3*HB+SKIP);
    yph=SKIP+HH*((hinnr-18) % 7);
    brh=3*HB;
    hoh=HH;}
  else if (hinnr > -1){
    xph=SKIP+HB*((int)(hinnr % 9));
    yph=6*(SKIP+HH)+SKIP+(2*HH+SKIP)*((int)(hinnr /9));
    brh=HB;
    hoh=2*HH;}

  if (flag){
    if (hilfestr[0]=='+')
      XAllocNamedColor(xdsp, xcm, "green", &def, &rgb);
    else
      XAllocNamedColor(xdsp, xcm, "red", &def, &rgb);
    XSetForeground(xdsp, xgc, def.pixel);
    XDefineCursor(xdsp, xwin, xc3);}
  else{
    XSetForeground(xdsp, xgc, xbp);
    XDefineCursor(xdsp, xwin, xc1);}

  XDrawRectangle(xdsp, xwin, xgc, xpf, ypf, brf, hof);
  XDrawRectangle(xdsp, xwin, xgc, xph, yph, brh, hoh);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von hilfeanzeigen\n");
fflush(NULL);
#endif
}

/*
 * Der Spielaufbau kann ja etwas dauern, und daher ist es sicherlich
 * sinnvoll eine kleine Fortschrittsanzeige anzubringen, die einem
 * sagt, ob sich denn auch noch was tut. Dies wird hier erledigt.
 */
void fortschritt(void){
  int breite, hoehe, x, y;
  int bf, bz, bs;
  char bname[100];

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von fortschritt\n");
fflush(NULL);
#endif
  breite=6*(SKIP+FB)+3*(SKIP+3*HB)+SKIP;
  hoehe=6*(SKIP+HH)+2*(SKIP+2*HH)+SKIP;
  x=zufall(0, breite-HB);
  y=zufall(0, hoehe-HH);
  bf=zufall(0,1);
  bz=zufall(0,5);
  bs=zufall(0,5);
  strcpy(bname, BASENAME);
  strcat(bname, bildname[bf][bz][bs]);
  putpix(bname, x, y, HB, HH);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von fortschritt\n");
fflush(NULL);
#endif
}

/*
 * Die Darstellung von Level und Zeit soll in einem Rahmen
 * zusammengefasst werden. Mit der Darstellung der Zeit gibt es noch
 * einige Probleme, die ich aber sicher auch noch loesen werde.
 *
 * Level und Zeit werden immer zusammendargestellt.
 *
 */
void information(void){
  int		x, y, b, h;
  GC		localgc;
  XGCValues	localvalues;
  unsigned long	localmask;
  char		level[20];

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von information\n");
fflush(NULL);
#endif
#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: Beginn von Information\n");
fflush(NULL);
#endif

  if (!laeuftputpix){
    /*
     * Da zu diesem Zeitpunkt nicht bekannt ist, wieviele Anfragen schon
     * an die X-Library gestellt sind, wird erst einmal alles
     * syncronisiert, damit keine Fehler passieren
     */
    XSync(xdsp, False);
  
#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: X-Server syncronisiert\n");
fflush(NULL);
#endif

    localmask=GCForeground | GCBackground | GCLineWidth;
    localvalues.foreground=xbp;
    localvalues.background=xwp;
    localvalues.line_width=1;
    localgc=XCreateGC(xdsp, xwin, localmask, &localvalues);

#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: GC hergestellt\n");
fflush(NULL);
#endif

    /* Der GC ist erstellt, nun kommt das zugrundeliegende Rechteck */
    x=6*(FB+SKIP)+SKIP;
    y=6*(HH+SKIP)+(int)(SKIP/2);
    b=3*HB;
    h=HH;
    XFillRectangle(xdsp, xwin, localgc, x, y, b, h);

#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: Rechteck gezeichnet\n");
fflush(NULL);
#endif

    /* Jetzt der Schriftzug und der Level */
    sprintf(level,"Spiel Nummer: %d",spielnummer);
    x+=5;
    y=y+5+xfi->ascent;
    XSetForeground(xdsp, localgc, xwp);
    XDrawString(xdsp, xwin, localgc, x, y, level, strlen(level));

#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: Spielnummer geschrieben\n");
fflush(NULL);
#endif

    /* Abschliessend wird noch die laufende Zeit geschrieben */
    y=y+10+xfi->ascent+xfi->descent;
    strcpy(level, zeitdarstellung());
    XDrawString(xdsp, xwin, localgc, x, y, level, strlen(level));

#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: Zeit geschrieben (%s)\n",level);
fflush(NULL);
#endif

    /* Abschliessend wird der GC wieder frei gegeben und die Ausgabe
     * garantiert */
    XFlush(xdsp);
    XFreeGC(xdsp, localgc);

#ifdef INFORMATIONDEBUG
fprintf(stderr,"information: GC freigegeben und Flush\n\n");
fflush(NULL);
#endif

  }

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von information\n");
fflush(NULL);
#endif
}

/*
 * Es ist sicherlich ueberlegenswert, ob die Timerroutine ausgerechnet
 * hier in diese Datei muss, aber ich halte sie hier fuer angemessen,
 * da sie, neben der Inkrementierung des Zeitzaehlers, auch die
 * Anzeige der aktuellen Zeit realisiert.
 */
void zeitansage(int dummy){
#ifdef ANZEIGEDEBUG
fprintf(stderr,"anzeige: Beginn von zeitansage\n");
fflush(NULL);
#endif
  /* Zunaechst das Inkrementieren des Zaehlers */
  zeit++;
  information();
  /* Auch beim naechsten Signal soll hierhin verzweigt werden */
  signal(SIGALRM, &zeitansage);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"anzeige: Ende von zeitansage\n");
fflush(NULL);
#endif
}


/*
 * Zum Abschluss noch die beiden Routinen, die im Erfolgs- bzw.
 * Misserfolgsfall aufgerufen werden --- Die Namen sprechen fuer sich.
 */
void feuerwerk(void){
  int durchlaeufe, maxzahl, zufzahl;
  int breite, hoehe;
  int x, y, dx, dy;
  int bf, bz, bs;
  char bname[100];
  int xf[8], yf[8], dxf[8], dyf[8];
  int stern, auslauf;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von feuerwerk\n");
fflush(NULL);
#endif
  breite=6*(SKIP+FB)+3*(SKIP+3*HB)+SKIP;
  hoehe=6*(SKIP+HH)+2*(SKIP+2*HH)+SKIP;
  for (durchlaeufe=0; durchlaeufe<70; durchlaeufe++){
    x=zufall(0, breite-HB);
    y=zufall(0, hoehe-HH);
    do{
      dx=zufall(-1,1)*zufall(3,17);
      dy=zufall(-1,1)*zufall(3,17);}
    while ((dx==0) && (dy==0));
    bf=zufall(0,1);
    bz=zufall(0,5);
    bs=zufall(0,5);
    zufzahl=zufall(10,100);
    maxzahl=0;
    strcpy(bname, BASENAME);
    strcat(bname, bildname[bf][bz][bs]);
    while ((x+dx < (breite-HB)) &&
           (x+dx > 0) &&
	   (y+dy < (hoehe-HH)) &&
	   (y+dy > 0) &&
	   (maxzahl < zufzahl)){
      x=x+dx; y=y+dy; maxzahl++;
      putpix(bname, x, y, HB, HH);}
    if (nurpos==True){
      /* Aenderung am 6.9.1999
         Hier soll nun ein wirkliches Feuerwerk beginnen */
      dxf[0]=  0; dyf[0]=-15;
      dxf[1]= 10; dyf[1]=-10;
      dxf[2]= 15; dyf[2]=  0;
      dxf[3]= 10; dyf[3]= 10;
      dxf[4]=  0; dyf[4]= 15;
      dxf[5]=-10; dyf[5]= 10;
      dxf[6]=-15; dyf[6]=  0;
      dxf[7]=-10; dyf[7]=-10;
      for (stern=0; stern<8; stern++){
        xf[stern]=x; yf[stern]=y;
      }
      for (auslauf=0; auslauf < 10; auslauf++){
        for (stern=0; stern<8; stern++){
	  xf[stern]=xf[stern]+dxf[stern];
	  yf[stern]=yf[stern]+dyf[stern];
	  if ((xf[stern] < (breite-HH)) &&
	      (xf[stern] > 0) &&
	      (yf[stern] < (hoehe-HH)) &&
	      (yf[stern] > 0)) putpix(bname, xf[stern], yf[stern], HB, HH);
	}
      }
    }
  }
  XFlush(xdsp);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von Feuerwerk\n");
fflush(NULL);
#endif
}

void trauer(void){
  int durchlaeufe;
  int x1, x2, y1, y2, breite, hoehe;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von trauer\n");
fflush(NULL);
#endif
  breite=6*(SKIP+FB)+3*(SKIP+3*HB)+SKIP;
  hoehe=6*(SKIP+HH)+2*(SKIP+2*HH)+SKIP;
  XSetForeground(xdsp, xgc, xbp);
  for (durchlaeufe=0; durchlaeufe<100; durchlaeufe++){
    x1=zufall(0,breite); x2=zufall(0,breite);
    y1=zufall(0,hoehe); y2=zufall(0,hoehe);
    XDrawLine(xdsp, xwin, xgc, x1, y1, x2, y2);}
  XFlush(xdsp);
  sleep(1);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von trauer\n");
fflush(NULL);
#endif
}

/*
 * Hier erfolgt die Nachfrage, ob noch ein Spiel gespielt werden soll.
 * Das Ergebnis wird als Charakter zurueckgegeben.
 */
char nachfrage(void){
  XEvent hilfe;
  char ergebnis;

#ifdef ANZEIGEDEBUG
fprintf(stderr,"Anfang von nachfrage\n");
fflush(NULL);
#endif
  ergebnis=2;
  XMapWindow(xdsp, xnf);
  XMapWindow(xdsp, xnj);
  XMapWindow(xdsp, xnn);
  XSetForeground(xdsp, xgc, xbp);
  XDrawString(xdsp, xnf, xgc, 75, 10, "Noch ein Spiel?", 15);
  XDrawString(xdsp, xnj, xgc, 10, 30, "Ja", 2);
  XDrawString(xdsp, xnn, xgc, 10, 30, "Nein", 4);
  do{
    XNextEvent(xdsp, &hilfe);
    if (hilfe.type==ButtonPress){
      if (hilfe.xbutton.window==xnj) ergebnis=1;
      if (hilfe.xbutton.window==xnn) ergebnis=0;}}
  while (ergebnis==2);
  XUnmapWindow(xdsp, xnf);
  XUnmapWindow(xdsp, xnj);
  XUnmapWindow(xdsp, xnn);
  return(ergebnis);
#ifdef ANZEIGEDEBUG
fprintf(stderr,"Ende von nachfrage\n");
fflush(NULL);
#endif
}

