/*
 * In dieser Datei werden die Hinweise erzeugt.
 * Hier finden sich auch alle Routinen, die die Art des Hinweises
 * aussuchen und danach entscheiden.
 * Letztlich sind hier die Routinen untergebracht, die die Hinweise
 * verwalten.
 */

#include "xmik.h"

extern char feld[3][6][6][6];
extern struct tip hinweis[2][39];
extern int hinschalter;

extern int zufall(int von, int bis);
extern char gesetzt(int feld, int zeile, int spalte);
extern void setze(int feld, int zeile, int spalte, int wert);
extern int suchspalte(int zeile, int bild);

/* Fuer die folgenden Programmteile ist es notwendig, dass Felder
 * ausgesucht werden. Dies geschieht dadurch, dass geprueft wird,
 * welche Felder schon in Hinweisen genutzt wurden und dann versucht
 * wird eines zu funden, das bisher so wenig wie moeglich genutzt
 * wurde.
 *
 * Fuer die Uebergabe gibt es eine dateiweit-globale Variable. */

struct hilfsstruct{
  int zeile, bild, zeile2, bild2, zeile3, bild3;
  char exzeile[7], exspalte[7];};

struct hilfsstruct uebergabe;
struct tip hinw;
int tabelle[36];

/* Erhoeht die Tabelle */
void add(struct tip woher, int wieviele){
  int i, z, b;

  for (i=0; i<wieviele; i++){
    z=woher.www[i*2]-'0';
    b=woher.www[i*2+1]-'0';
    tabelle[z*6+b]++;}}

/* Die folgende Routine sucht ein neues Feld heraus.
 * Das Vorgehen ist das folgende:
 * Zunaechst wird eine Tabelle angelegt, die die Haeufigkeiten
 * enthaelt, mit denen ein Hinweis schon vorkommt. Aus dieser Tabelle
 * werden dann alle Hinweise entfernt, die nicht den
 * Exklusionsbedingungen entsprechen. Von den verbleibenden Eintraegen
 * wird der ausgewaehlt, der bisher am wenigsten vorkam. */

void neuesfeld(void){
  int i, j, z, s, beginn, index, minimum;
  char g;

  /* Tabelle initialisieren */
  for (i=0; i<36; i++) tabelle[i]=0;

  /* Gesetzte Felder ermitteln */
  for (i=0; i<6; i++){
    for (j=0; j<6; j++){
      g=gesetzt(1, i, j);
      if (g) tabelle[i*6+g-'0']++;}}

  /* Hinweise durchstoebern */
  for (i=0; i<39; i++){
    if (hinweis[hinschalter][i].typ){
      switch (hinweis[hinschalter][i].typ){
        case 1 : {add(hinweis[hinschalter][i], 2); break;}
        case 2 : {add(hinweis[hinschalter][i], 2); break;}
        case 3 : {add(hinweis[hinschalter][i], 2); break;}
        case 4 : {add(hinweis[hinschalter][i], 2); break;}
        case 5 : {add(hinweis[hinschalter][i], 2); break;}
        case 6 : {add(hinweis[hinschalter][i], 3); break;}
        case 7 : {add(hinweis[hinschalter][i], 3); break;}
	default : break;}}}

  /* Nun werden alle die Eintraege entfernt, die durch die
   * Exklusionsbedingungen ausgeschlossen sind.
   * Die Exklusionsbedingungen sehen folgendermassen aus. Fuer die
   * Zeile und die Spalte gibt es einen String, der aus sechs Zeichen
   * besteht. Steht an der Stelle ein `x', dann darf die Spalte oder
   * die Zeile sein, anderenfalls nicht. Der Eintrag wird uebrigens
   * nicht geloescht, sondern einfach auf 1000 gesetzt, somit wird er
   * dann spaeter nicht mehr gefunden. */
    
    for (i=0; i<36; i++){ /* Durchlaeuft die ganze Tabelle */
      z=(int)(i / 6);
      s=suchspalte(z, ((int)(i % 6)));
      if ((uebergabe.exzeile[z] != 'x') ||
          (uebergabe.exspalte[s] != 'x')) tabelle[i]=1000;}

  /* Nun kann der Hinweis ermittelt werden, der bisher die geringste
   * Haeufigkeit hat. Damit nicht immer die gleichen gefunden werden,
   * wird die Suche in der Mitte der Tabelle begonnen. */

  beginn=zufall(0,35);
  i=index=beginn;
  minimum=tabelle[i];
  do{
    i++;
    if (i > 35) i=0;
    if (tabelle[i] < minimum){
      minimum=tabelle[i]; index=i;}}
  while (i != beginn);

  /* Abschliessend wird das Ergebnis noch in die Uebergabevariable
   * eingetragen. */
  uebergabe.zeile=(int)(index / 6);
  uebergabe.bild=(int)(index % 6);}

/* Die eigentliche Arbeit wird in den Unterprogrammen geleistet. Diese
 * stehen erst einmal hier. */
/*
 *
 * HINWEIS 0
 *
 */
/* Der nullte Hinweistyp deckt einfach ein Feld auf. */
char machtyp0(void){
  int s, anzahl;
  char erledigt;

  hinw.typ=0;
  erledigt=False;
  anzahl=0;
  do{
    anzahl++;
    strcpy(uebergabe.exzeile, "xxxxxx");
    strcpy(uebergabe.exspalte, "xxxxxx");
    neuesfeld();
    s=suchspalte(uebergabe.zeile, uebergabe.bild);
    if (!gesetzt(1, uebergabe.zeile, s)){
      setze(1, uebergabe.zeile, s, uebergabe.bild);
      setze(2, uebergabe.zeile, s, uebergabe.bild);
      erledigt=True;}}
  while ((anzahl < 100) && (!erledigt));
  return(erledigt);}

/*
 *
 * HINWEIS 1
 *
 */
/* Der Hinweis des ersten Typs besagt, dass zwei Felder uebereinander
 * liegen. */
char machtyp1(void){
  int s;
  char t;

  hinw.typ=1;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"xxxxxx");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  strcpy(uebergabe.exzeile,"xxxxxx");
  uebergabe.exzeile[uebergabe.zeile]=' ';
  strcpy(uebergabe.exspalte,"      ");
  s=suchspalte(uebergabe.zeile, uebergabe.bild);
  uebergabe.exspalte[s]='x';
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  if (hinw.www[0] > hinw.www[2]){
    t=hinw.www[0];
    hinw.www[0]=hinw.www[2];
    hinw.www[2]=t;
    t=hinw.www[1];
    hinw.www[1]=hinw.www[3];
    hinw.www[3]=t;}
  return(True);}

/*
 *
 * HINWEIS 2
 *
 */
/*
 * Der zweite Hinweistyp besagt, dass zwei Bilder nicht uebereinander
 * vorkommen koennen. Es muss also nur ein Feld gesucht werden und
 * dann ein zweites, welches nicht ueber oder unter dem ersten liegt.
 */
char machtyp2(void){
  int s;
  char t;

  hinw.typ=2;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"xxxxxx");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  s=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  uebergabe.exzeile[uebergabe.zeile]=' ';
  strcpy(uebergabe.exspalte,"xxxxxx");
  uebergabe.exspalte[s]=' ';
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  if (hinw.www[0] > hinw.www[2]){
    t=hinw.www[0];
    hinw.www[0]=hinw.www[2];
    hinw.www[2]=t;
    t=hinw.www[1];
    hinw.www[1]=hinw.www[3];
    hinw.www[3]=t;}
  return(True);}

/*
 * Der nun folgende Hinweistyp 3 besagt, dass zwei Bilder in
 * nebeneinander liegenden Spalten vorkommen.
 * Er ist der erste Hinweistyp, der rehts neben dem Spielfeld
 * dargestellt wird.
 */
char machtyp3(void){
  int i, s;
  
  hinw.typ=3;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte," xxxx ");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  hinw.www[4]=uebergabe.zeile+'0';
  hinw.www[5]=uebergabe.bild+'0';
  s=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"      ");
  for (i=0; i<6; i++){
    if ((i==s-1) || (i==s+1)) uebergabe.exspalte[i]='x';}
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  return(True);}

/*
 * Der vierte Hinweistyp besagt, dass zwei Bilder nicht unmittelbar
 * nebeneinander vorkommen duerfen.
 */
char machtyp4(void){
  int s, i;

  hinw.typ=4;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"xxxxxx");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  hinw.www[4]=uebergabe.zeile+'0';
  hinw.www[5]=uebergabe.bild+'0';
  s=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"xxxxxx");
  for (i=0; i<6; i++){
    if ((i==s-1) || (i==s+1) || (i==s)) uebergabe.exspalte[i]=' ';}
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  return(True);}

/*
 * Der Hinweistyp des fuenften Typs besagt, dass ein Bild rechts, bzw.
 * links von einem anderen vorkommt.
 */
char machtyp5(void){
  int s, i;

  s=0;
  for (i=18; i<39; i++) if (hinweis[hinschalter][i].typ==5) s++;
  if (s<MAXFUENF){
    hinw.typ=5;
    strcpy(uebergabe.exzeile,"xxxxxx");
    strcpy(uebergabe.exspalte,"xxxxx ");
    neuesfeld();
    hinw.www[0]=uebergabe.zeile+'0';
    hinw.www[1]=uebergabe.bild+'0';
    s=suchspalte(uebergabe.zeile, uebergabe.bild);
    strcpy(uebergabe.exzeile,"xxxxxx");
    strcpy(uebergabe.exspalte,"xxxxxx");
    for (i=0; i<=s; i++) uebergabe.exspalte[i]=' ';
    neuesfeld();
    hinw.www[2]=uebergabe.zeile+'0';
    hinw.www[3]=uebergabe.bild+'0';
    return(True);}
  else return(False);}

/*
 * Der folgende Hinweistyp besagt, das drei Bilder in einer Reihe
 * liegen. Es wird allerdings keine Aussage darueber gemacht, ob von
 * rechts nach links, oder von links nach rechts.
 */
char machtyp6(void){
  int i,s1,s2;

  hinw.typ=6;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"  xx  ");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"      ");
  s1=suchspalte(uebergabe.zeile, uebergabe.bild);
  for (i=0; i<6; i++)
    if ((i == s1-1) || (i==s1+1)) uebergabe.exspalte[i]='x';
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  s2=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"      ");
  if (s2 > s1) uebergabe.exspalte[s2+1]='x';
  else uebergabe.exspalte[s1-2]='x';
  neuesfeld();
  hinw.www[4]=uebergabe.zeile+'0';
  hinw.www[5]=uebergabe.bild+'0';
  return(True);}

/*
 * Der letzte Typ aehnelt dem vorletzten, mit der Ausnahme, dass das
 * mittig angegebene Feld eben nicht zwischen dem ersten und dem
 * dritten liegen darf.
 */
char machtyp7(void){
  int i, s1, s2, z;

  hinw.typ=7;
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"xxxxxx");
  neuesfeld();
  hinw.www[0]=uebergabe.zeile+'0';
  hinw.www[1]=uebergabe.bild+'0';
  s1=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  strcpy(uebergabe.exspalte,"      ");
  for (i=0; i<6; i++)
    if ((i==s1-2) || (i==s1+2)) uebergabe.exspalte[i]='x';
  neuesfeld();
  hinw.www[4]=uebergabe.zeile+'0';
  hinw.www[5]=uebergabe.bild+'0';
  s2=suchspalte(uebergabe.zeile, uebergabe.bild);
  strcpy(uebergabe.exzeile,"xxxxxx");
  z=zufall(0,9);
  if (z < 2){
    s1=(int)((s1+s2)/2);
    strcpy(uebergabe.exspalte,"xxxxxx");
    uebergabe.exspalte[s1]=' ';}
  else{
    strcpy(uebergabe.exspalte,"      ");
    if (s1 < s2){
      if (s1 > 0) uebergabe.exspalte[s1-1]='x';
      if (s2 < 5) uebergabe.exspalte[s2+1]='x';}
    else{
      if (s1 < 5) uebergabe.exspalte[s1+1]='x';
      if (s2 > 0) uebergabe.exspalte[s2-1]='x';}}
  neuesfeld();
  hinw.www[2]=uebergabe.zeile+'0';
  hinw.www[3]=uebergabe.bild+'0';
  return(True);}

/* Nun folgt das eigentliche Hauptprogramm dieser Datei. */

struct tip genhinw(void){
  int vorwahl, typ;
  char ergebnis;

  do{
    hinw.typ=-1;
    /* Auswahl des zu generierenden Typs */
    vorwahl=zufall(1,100);
    typ=0;			/* Anzeigen			*/
    if (vorwahl >  2) typ=1;	/* Uebereinander		*/
    if (vorwahl > 23) typ=2;	/* Nicht uebereinander		*/
    if (vorwahl > 31) typ=3;	/* Nebeneinander		*/
    if (vorwahl > 71) typ=4;	/* Nicht nebeneinander		*/
    if (vorwahl > 72) typ=5;	/* Rechts-Links			*/
    if (vorwahl > 82) typ=6;	/* Dreier			*/
    if (vorwahl > 90) typ=7;	/* Dreier ohne Mitte		*/
    /*
    vorwahl=zufall(1,43); typ=0;

    if ((vorwahl >  0) && (vorwahl <  5)) typ=0;
    if ((vorwahl >  4) && (vorwahl < 21)) typ=1;
    if ((vorwahl > 20) && (vorwahl < 23)) typ=2;
    if ((vorwahl > 22) && (vorwahl < 33)) typ=3;
    if ((vorwahl > 32) && (vorwahl < 35)) typ=4;
    if ((vorwahl > 34) && (vorwahl < 36)) typ=5;
    if ((vorwahl > 35) && (vorwahl < 41)) typ=6;
    if ((vorwahl > 40) && (vorwahl < 44)) typ=7;
    */
    
    /* Generierung des ausgesuchten Typs */
    ergebnis=False;
    switch (typ){
      case 0 : {ergebnis=machtyp0(); break;}
      case 1 : {ergebnis=machtyp1(); break;}
      case 2 : {ergebnis=machtyp2(); break;}
      case 3 : {ergebnis=machtyp3(); break;}
      case 4 : {ergebnis=machtyp4(); break;}
      case 5 : {ergebnis=machtyp5(); break;}
      case 6 : {ergebnis=machtyp6(); break;}
      case 7 : {ergebnis=machtyp7(); break;}
      default : break;}}
   while (!ergebnis);

  return(hinw);}

