/*
 * Diese Datei enthaelt alle Routinen, die eine Hilfe ausgeben. Das
 * Ergebnis wird in einer eigenen Hilfevariablen abgelegt.
 */
#include "xmik.h"
#include <strings.h>

extern char	hilfestr[10];
extern char	hilfeflag;
extern char	feld[3][6][6][6];
extern struct tip hinweis[2][39];
extern int	hinschalter;

extern char gesetzt(int feld, int zeile, int spalte);
extern int suchspalte(int zeile, int bild);
extern void loescheueberfluessiges(void);
extern int urechts(int zeile, int spalte, int bild);
extern int ulinks(int zeile, int spalte, int bild);
extern int urechtsm(int zeile, int spalte, int bild);
extern int ulinksm(int zeile, int spalte, int bild);
extern int rechts(int zeile, int spalte, int bild);
extern int links(int zeile, int spalte, int bild);
extern int rechtsm(int zeile, int spalte, int bild);
extern int linksm(int zeile, int spalte, int bild);
extern int zrechtsm(int zeile, int spalte, int bild);
extern int zlinksm(int zeile, int spalte, int bild);
extern int sicher(int zeile, int spalte, int bild);
extern void hilfeanzeigen(char *string, char flag);

/*
 * Einige Variablen sollten ruhig global vorliegen, das spart Platz.
 */
int z1, z2, z3, s1, s2, s3, b1, b2, b3;
char c1, c2, c3, re, li;

/*
 * Test auf alleiniges Vorkommen eines Bildes in einer Zeile
 */
 
void vielleichtdie(int zeile, int welche){
  int anzahl, s, h;
  char c;

  anzahl=0; h=0;
  for (s=0; s<6; s++){
      if (feld[1][zeile][s][welche] == welche+'0'){
        h=s; anzahl++;}}
  c=gesetzt(1, zeile, h);
  if ((anzahl==1) && (c=='\0')){
    sprintf(hilfestr,"+%d%d%d", zeile, h, welche);}}

void testaufalleine(void){
  int z;

  z=0;
  do{
    /* Innerhalb der Zeile wird untersucht, wie oft jedes Bild
     * vorkommt. Wird ein Bild gefunden, dass nur einmal vorkommt,
     * dann kann der entsprechende Befehl erzeugt werden. */
    vielleichtdie(z, 0);
    if (!hilfestr[0]) vielleichtdie(z, 1);
    if (!hilfestr[0]) vielleichtdie(z, 2);
    if (!hilfestr[0]) vielleichtdie(z, 3);
    if (!hilfestr[0]) vielleichtdie(z, 4);
    if (!hilfestr[0]) vielleichtdie(z, 5);
    z++;}
  while ((!hilfestr[0]) && (z<7));
  if (hilfestr[0]) strcat(hilfestr,".a");}

/* Da in allen nun folgenden Routinen immer wieder dieselben Variablen
 * gesetzt werden, kann das auch durch ein Unterprogramm erledigt
 * werden. */
void setzevariablen(int nr){
  z1=hinweis[hinschalter][nr].www[0]-'0';
  b1=hinweis[hinschalter][nr].www[1]-'0';
  z2=hinweis[hinschalter][nr].www[2]-'0';
  b2=hinweis[hinschalter][nr].www[3]-'0';
  z3=hinweis[hinschalter][nr].www[4]-'0';
  b3=hinweis[hinschalter][nr].www[5]-'0';
  s1=suchspalte(z1, b1);
  s2=suchspalte(z2, b2);
  s3=suchspalte(z3, b3);
  c1=gesetzt(1, z1, s1);
  c2=gesetzt(1, z2, s2);
  c3=gesetzt(1, z3, s3);}

/*
 * Hier folgen die Routinen, die einen einzelnen Hinweis testen. Sie
 * sind nach Typnummer des Hinweises geoerdnet, zuerst die Hinweise
 * des ersten Typs
 *
 * Dieser Hinweis besagt, dass ein Bild ueber einem anderen vorkommt.
 * Hieraus ergeben sich zwei Moeglichkeiten:
 * 1. kann es sein, dass eines der Bilder schon gesetzt ist, das
 * andere aber noch nicht, in diesem Fall wird ein positiver Befehl
 * erzeugt, der auch das andere Bild setzt.
 * 2. kann es sein, dass Bild an einer Stelle nicht mehr moeglich ist,
 * wohl aber noch das andere Bild. In diesem Fall wird ein negativer
 * Befehl erzeugt, der auch das zweite Bild loescht.
 */
void teste1p(int nr){
  setzevariablen(nr);
  /* Zunaechst die positive Moeglichkeit */
  if ((c1==b1+'0') && (c2=='\0'))
    sprintf(hilfestr,"+%d%d%d.1.%d", z2, s2, b2, nr);
  if ((c1=='\0') && (c2==b2+'0'))
    sprintf(hilfestr,"+%d%d%d.1.%d", z1, s1, b1, nr);}

void teste1n(int nr){
  setzevariablen(nr);
  /* Falls bis hier nichts passiert ist, wird nun die negative
   * Moeglichkeit getestet. */
  for (s1=0; s1<6; s1++){
    c1=feld[1][z1][s1][b1];
    c2=feld[1][z2][s1][b2];
    if (!hilfestr[0]){
      if ((c1==b1+'0') && (c2==' '))
	sprintf(hilfestr,"-%d%d%d.1.%d",z1,s1,b1,nr);
      if ((c1==' ') && (c2==b2+'0'))
	sprintf(hilfestr,"-%d%d%d.1.%d",z2,s1,b2,nr);}}}

/*
 *
 * HINWEIS 2
 *
 */
/*
 * Der zweite Hinweistyp, der besagt, dass ein Bild nicht ueber einem
 * anderen vorkommen kann, erzeugt nur negative Befehle und das auch
 * nur dann, wenn eines der Bilder gesetzt ist und das andere
 * darueber, oder darunter noch moeglich ist.
 */
void teste2p(int nr){}
void teste2n(int nr){
  setzevariablen(nr);
  if ((c1==b1+'0') && (feld[1][z2][s1][b2] != ' '))
    sprintf(hilfestr,"-%d%d%d.2.%d",z2,s1,b2,nr);
  if ((c2==b2+'0') && (feld[1][z1][s2][b1] != ' '))
    sprintf(hilfestr,"-%d%d%d.2.%d",z1,s2,b1,nr);}

/*
 *
 * HINWEIS 3
 *
 */
/*
 * Der Hinweis Nummer 3 besagt, dass zwei Bilder nebeneinander liegen.
 * Dieser Hinweis kann sowohl positive, als auch negative Befehle
 * erwirken.
 * Ein positiver Befehl wird dann erzeugt, wenn eines der Bilder schon
 * gesetzt ist und das andere nur noch auf einer Seite moeglich ist.
 * Ein negativer Befehl wird erzeugt, wenn rechts und links von einem
 * moeglichen Bild das andere nicht mehr vorkommt.
 */
void teste3p(int nr){
  setzevariablen(nr);
  /* Zunaechst wird die positive Moeglichkeit getestet */
  if (c1==b1+'0'){ /* Erstes Zeichen ist gesetzt */
    if (((ulinks(z2, s1, b2)) && (!urechts(z2, s1, b2))) ||
        ((!ulinks(z2, s1, b2)) && (urechts(z2, s1, b2))))
      sprintf(hilfestr,"+%d%d%d.3.%d",z2,s2,b2,nr);}
  if (c2==b2+'0'){ /* Zweites Zeichen ist gesetzt */
    if (((ulinks(z1, s2, b1)) && (!urechts(z1, s2, b1))) ||
        ((!ulinks(z1, s2, b1)) && (urechts(z1, s2, b1))))
      sprintf(hilfestr,"+%d%d%d.3.%d",z1,s1,b1,nr);}}

void teste3n(int nr){
  int s;

  setzevariablen(nr);

  /* Nun kommt die negative Variante */
  /* Zuerst wird das erste Bild getestet */
  for (s=0; s<6; s++){
    if ((feld[1][z2][s][b2]==b2+'0') &&
        (!urechtsm(z1, s, b1)) && (!ulinksm(z1, s, b1)))
      sprintf(hilfestr,"-%d%d%d.3.%d",z2,s,b2,nr);}

  /* Dann wird das zweite Bild getestet */
  for (s=0; s<6; s++){
    if ((feld[1][z1][s][b1]==b1+'0') &&
        (!urechtsm(z2, s, b2)) && (!ulinksm(z2, s, b2)))
      sprintf(hilfestr,"-%d%d%d.3.%d",z1,s,b1,nr);}}
/*
 * Der Hineistyp Nummer 4 besagt, dass ein Bild nicht neben dem
 * anderen vorkommt. Dieser Hinweeis laesst nur negative Befehle zu.
 */
void teste4p(int nr){}
void teste4n(int nr){
  setzevariablen(nr);

  if ((c1==b1+'0') && (ulinksm(z2, s1, b2)))
    sprintf(hilfestr,"-%d%d%d.4.%d",z2,s1-1,b2,nr);
  else if ((c1==b1+'0') && (urechtsm(z2, s1, b2)))
    sprintf(hilfestr,"-%d%d%d.4.%d",z2,s1+1,b2,nr);
  else if ((c2==b2+'0') && (ulinks(z1, s2, b1)))
    sprintf(hilfestr,"-%d%d%d.4.%d",z1, s2-1, b1, nr);
  else if ((c2==b2+'0') && (urechtsm(z1, s2, b1)))
    sprintf(hilfestr,"-%d%d%d.4.%d",z1,s2+1,b1,nr);}

/*
 * Der fuenfte Hinweistyp besagt, dass ein Bild rechts, bzw. links von
 * einem anderen liegen muss. Dieser Befehl ermoeglicht wieder einen
 * positiven und einen negativen Befehl.
 * Positiv dann, wenn neben einem gesetzten Bild nur noch eine
 * Moeglichkeit fuer das andere Bild besteht, negativ dann, wenn es
 * auf der einen Seite keine entsprechenden Bilder mehr gibt.
 */
void teste5p(int nr){
  int hilfe;
  
  setzevariablen(nr);
  if (c1==b1+'0'){
    hilfe=rechts(z2, s1, b2);
    if (hilfe != 0)
      sprintf(hilfestr,"+%d%d%d.5.%d",z2,hilfe,b2,nr);}
  if (c2==b1+'0'){
    hilfe=links(z1, s2, b1);
    if (hilfe != -1)
      sprintf(hilfestr,"+%d%d%d.5.%d",z1,hilfe,b1,nr);}}

void teste5n(int nr){
  int s;
  
  setzevariablen(nr);
  for (s=0; s<6; s++){
    if ((feld[1][z1][s][b1]==b1+'0') && (!rechtsm(z2,s,b2)))
      sprintf(hilfestr,"-%d%d%d.5.%d",z1,s,b1,nr);
    if ((feld[1][z2][s][b2]==b2+'0') && (!linksm(z1,s,b1)))
      sprintf(hilfestr,"-%d%d%d.5.%d",z2,s,b2,nr);}}

/*
 * Der nun folgende Test ueberprueft einen Hinweis des Typs sechs.
 * Dieser Hinweis besagt, dass drei Bilder unmittelbar nebeneinander
 * liegen. Wegen der Unmenge von Moeglichkeiten, die dieser Hinweis
 * bietet, wird fuer jedes Bild des Hinweises nur fuer jede Spalte
 * getestet, ob das Bild noch moeglich ist, also es werden nur
 * negative Hinweise erzeugt. Das ist sicherlich nicht die optimale
 * Loesung, aber programmtechnisch bedeutend einfacher.
 *
 * Und schon wieder schlaegt die Lust am Programmieren zu und es wird
 * nun doch versucht auch die positive Routine zu schreiben.
 */
void teste6p(int nr){
  int bekannte;

  setzevariablen(nr);
  bekannte=0;
  if (c1==b1+'0') bekannte++;
  if (c2==b2+'0') bekannte++;
  if (c3==b3+'0') bekannte++;
  /* Im folgenden wird nun unterschieden, wieviele Felder schon
   * bekannt sind. Interessant sind die Faelle, in denen ein oder zwei
   * Bilder schon bekannt sind. */
  if (bekannte==1){
    if (c1==b1+'0'){
      if ((zrechtsm(z3,s1,b3)) && (!zlinksm(z3,s1,b3)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z3,s3,b3,nr);
      if ((!zrechtsm(z3,s1,b3)) && (zlinksm(z3,s1,b3)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z3,s3,b3,nr);
      if ((urechtsm(z2,s1,b2)) && (!ulinksm(z2,s1,b2)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z2,s2,b2,nr);
      if ((!urechtsm(z2,s1,b2)) && (ulinksm(z2,s1,b2)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z2,s2,b2,nr);}
    if (c2==b2+'0'){
      if ((urechtsm(z1,s2,b1)) && (!ulinksm(z1,s2,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z1,s1,b1,nr);
      if ((!urechtsm(z1,s2,b1)) && (ulinksm(z1,s2,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z1,s1,b1,nr);
      if ((urechtsm(z3,s2,b3)) && (!ulinksm(z3,s2,b3)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z3,s3,b3,nr);
      if ((!urechtsm(z3,s2,b3)) && (ulinksm(z3,s2,b3)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z3,s3,b3,nr);}
    if (c3==b3+'0'){
      if ((zrechtsm(z1,s3,b1)) && (!zlinksm(z1,s3,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z1,s1,b1,nr);
      if ((!zrechtsm(z1,s3,b1)) && (zlinksm(z1,s3,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z1,s1,b1,nr);
      if ((urechtsm(z1,s3,b1)) && (!ulinksm(z1,s3,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z2,s2,b2,nr);
      if ((!urechtsm(z1,s3,b1)) && (ulinksm(z1,s3,b1)))
        sprintf(hilfestr,"+%d%d%d.6.%d",z2,s2,b2,nr);}}
  if (bekannte==2){
    if (c1 != b1+'0') sprintf(hilfestr,"+%d%d%d.6.%d",z1,s1,b1,nr);
    if (c2 != b2+'0') sprintf(hilfestr,"+%d%d%d.6.%d",z2,s2,b2,nr);
    if (c3 != b3+'0') sprintf(hilfestr,"+%d%d%d.6.%d",z3,s3,b3,nr);}}

void teste6n(int nr){
  int s;
  
  setzevariablen(nr);
  for (s=0; s<6; s++){
    if (feld[1][z1][s][b1]==b1+'0'){
      if ((!urechtsm(z2,s,b2)) && (!ulinksm(z2,s,b2))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z1,s,b1,nr);}
      if ((!zrechtsm(z3,s,b3)) && (!zlinksm(z3,s,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z1,s,b1,nr);}}

    if (feld[1][z2][s][b2]==b2+'0'){
      if ((!urechtsm(z1,s,b1)) && (!ulinksm(z1,s,b1))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z2,s,b2,nr);}
      if ((!urechtsm(z3,s,b3)) && (!ulinksm(z3,s,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z2,s,b2,nr);}}

    if (feld[1][z3][s][b3]==b3+'0'){
      if ((!urechtsm(z2,s,b2)) && (!ulinksm(z2,s,b2))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z3,s,b3,nr);}
      if ((!zrechtsm(z1,s,b1)) && (!zlinksm(z1,s,b1))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.6.%d",z3,s,b3,nr);}}}}

/*
 * Analog zum Test des letzten Hinweistyps werden bei diesem
 * Hinweistyp auch nur negative Befehle erzeugt, da sonst das Ganze
 * doch etwas sehr unuebersichtlich wird.
 *
 * Nun, es sind einige Tage vergangen und ich denke, dass es durchaus
 * Sinn machen kann mal etwas zu tun, was vielleicht etwas
 * unuebersichtlich ist.
 */
void teste7p(int nr){
  setzevariablen(nr);
  if ((c1==b1+'0') && (c3!=b3+'0')){
    if (!zrechtsm(z3, s1, b3))
      sprintf(hilfestr,"+%d%d%d.7.%d",z3,s3,b3,nr);
    if (!zlinksm(z3, s1, b3))
      sprintf(hilfestr,"+%d%d%d.7.%d",z3,s3,b3,nr);}
  if ((c3==b3+'0') && (c1!=b1+'0')){
    if (!zrechtsm(z1, s3, b1))
      sprintf(hilfestr,"+%d%d%d.7.%d",z1,s1,b1,nr);
    if (!zlinksm(z1, s3, b1))
      sprintf(hilfestr,"+%d%d%d.7.%d",z1,s1,b1,nr);}}

void teste7n(int nr){
  int s;

  setzevariablen(nr);
  for (s=0; s<6; s++){
    if (feld[1][z1][s][b1]==b1+'0'){
      if ((!zrechtsm(z3,s,b3)) && (!zlinksm(z3,s,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z1,s,b1,nr);}
      if ((sicher(z2,s-1,b2)) && (!zrechtsm(z3,s,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z1,s,b1,nr);}
      if ((sicher(z2,s+1,b2)) && (!zlinksm(z3,s,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z1,s,b1,nr);}}
    if (feld[1][z2][s][b2]==b2+'0'){
      if ((sicher(z1,s-1,b1)) && (sicher(z3,s+1,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z2,s,b2,nr);}
      if ((sicher(z1,s+1,b1)) && (sicher(z3,s-1,b3))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z2,s,b2,nr);}}
    if (feld[1][z3][s][b3]==b3+'0'){
      if ((!zrechtsm(z1,s,b1)) && (!zlinksm(z1,s,b1))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z3,s,b3,nr);}
      if ((sicher(z2,s-1,b2)) && (!zrechtsm(z1,s,b1))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z3,s,b3,nr);}
      if ((sicher(z2,s+1,b2)) && (!zlinksm(z1,s,b1))){
        if (!hilfestr[0])
	  sprintf(hilfestr,"-%d%d%d.7.%d",z3,s,b3,nr);}}}}

/*
 * Die folgende Routine testet einfach einen Hinweis. Eigentlich
 * testet sie nurden Typ des Hinweises und uebergibt dann die Arbeit
 * einem Unterprogramm.
 */
void testehinweisp(int nummer){
  switch (hinweis[hinschalter][nummer].typ){
    case 1 : {teste1p(nummer); break;}
    case 2 : {teste2p(nummer); break;}
    case 3 : {teste3p(nummer); break;}
    case 4 : {teste4p(nummer); break;}
    case 5 : {teste5p(nummer); break;}
    case 6 : {teste6p(nummer); break;}
    case 7 : {teste7p(nummer); break;}
    default: break;}}
void testehinweisn(int nummer){
  switch (hinweis[hinschalter][nummer].typ){
    case 1 : {teste1n(nummer); break;}
    case 2 : {teste2n(nummer); break;}
    case 3 : {teste3n(nummer); break;}
    case 4 : {teste4n(nummer); break;}
    case 5 : {teste5n(nummer); break;}
    case 6 : {teste6n(nummer); break;}
    case 7 : {teste7n(nummer); break;}
    default: break;}}

/*
 * Hier steht die generelle Routine, die eine Hilfe ausgibt.
 */
void hilfe(void){
  int hinnr;

  hilfestr[0]='\0'; hinnr=0;
  /* Es kann vorkommen, dass manche Eintraege im Feld ueberfluessig
   * geworden sind. Diese Eintraege muessen zuerst geloescht werden. */
  loescheueberfluessiges();
  /* Test, ob in einer Zeile ein Bild nur einmal vorkommt */
  testaufalleine();
  /* Nun werden die Hinweise getestet */
  if (!hilfestr[0]){
    hinnr=0;
    do{
      testehinweisp(hinnr);
      hinnr++;}
    while ((!hilfestr[0]) && (hinnr<39));}
    if (!hilfestr[0]){
      hinnr=0;
      do{
        testehinweisn(hinnr);
        hinnr++;}
      while ((!hilfestr[0]) && (hinnr<39));}}

/*
 * Und hier folgt die Routine, die eine Hilfe auswertet und im Fenster
 * ausgibt.
 */
void hilfeanforderung(void){

  if (hilfeflag==0){
    hilfe();
    hilfeflag=1;
    if (hilfestr[0]) hilfeanzeigen(hilfestr, 1);}
  else{
    hilfeflag=0;
    hilfeanzeigen(NULL, 0);}}
