/*
 * Diese Datei enthaelt alle Routinen, die mit der History-Funktion
 * des Spiels zu tun haben, also auch die Wiederholung alter Befehle.
 */

#include "xmik.h"
#include <unistd.h>

extern char befehl[BEFLEN];
extern struct hist root;
extern char feld[3][6][6][6];

extern void felddarstellung(void);
extern int interpretation(int feld);

/*
 * Die folgende Routine haengt einfach den Befehl an die Historyliste
 * an.
 */
void history(void){
  struct hist *p1;

  p1=&root;
  while (p1->next) p1=p1->next;
  p1->next=(struct hist *)malloc(sizeof(struct hist));
  p1=p1->next;
  p1->next=NULL;
  strcpy(p1->befehl, befehl);}

/*
 * Die folgende Routine loescht den letzten Eintrag in der
 * Historyliste.
 */
void dellasthist(void){
  struct hist *p1, *p2;

  p1=p2=&root;
  while (p1->next){
    p2=p1;
    p1=p1->next;}
  if (p1 != &root) free(p1);
  p2->next=NULL;}

/*
 * Die folgende Routine loescht den gesamten Speicher, der fuer die
 * History gebraucht wurde.
 */
void delhist(void){

  while (root.next) dellasthist();}

/*
 * Hier steht nun die Bearbeitung des Undo-Befehls
 */
void undobefehl(void){
  int z,s,b;
  struct hist *p;
  
  dellasthist();
  for (z=0; z<6; z++){
    for (s=0; s<6; s++){
      for (b=0; b<6; b++) feld[1][z][s][b]=feld[2][z][s][b];}}
  p=root.next;
  while (p){
    strcpy(befehl, p->befehl);
    befehl[strlen(befehl)-2]='\0';
    interpretation(1);
    p=p->next;}
    felddarstellung();}

/*
 * Hier folgt die Wiederholung des Spieles bis hier hin.
 */
void wiederholung(void){
  int z,s,b;
  struct hist *p;

  for (z=0; z<6; z++){
    for (s=0; s<6; s++){
      for (b=0; b<6; b++) feld[1][z][s][b]=feld[2][z][s][b];}}
  p=root.next;
  while (p){
    strcpy(befehl, p->befehl);
    befehl[strlen(befehl)-2]='\0';
    interpretation(1);
    felddarstellung();
    p=p->next;}}

/*
 * Und nun die Wiederholung bis zum ersten Fehler. Dazu werden
 * sollange Befehle aus der Historyliste gestrichen, bis kein Fehler
 * mehr auftritt.
 */
void bisfehler(void){
  struct hist *p;
  char c;

  do{
    p=&root;
    while (p->next) p=p->next;
    c=p->befehl[strlen(p->befehl)-1];
    if ((c != 'r') && (c != 'R')) dellasthist();}
  while ((c=='f') || (c=='F'));
  wiederholung();}

