/*
 * Hier finden sich nun all die Programmteile, die sonst keinen Platz
 * mehr gefunden haben.
 */

#include	"xmik.h"

extern Display	*xdsp;
extern Window	xwin;
extern GC	xgc;
extern Pixmap	xp1;

extern char	feld[3][6][6][6];
extern long int zeit;
extern char	zeitstr[20];

/*
 * Umwandlung einer Zeichenkette in eine Zahl.
 * Die Routine ist SEHR robust und ungenau!!!
 */

int zahlwert(char *ziffern){
  int ergebnis;
  char *ptr;

  ergebnis=0;
  ptr=ziffern;
  do{
    ergebnis*=10;
    ergebnis+=*ptr-'0';
    ptr++;}
  while (*ptr);
  return(ergebnis);}

/*
 * Berechnung einer Zufallszahl in einem bestimmten Bereich
 */

int zufall(int von, int bis){

  int ergebnis;
  ergebnis=von+(rand() % (bis-von+1));
  return(ergebnis);}

/*
 * Setzen eines bestimmten Wertes in einem der Spielfelder.
 */
void setze(int feldnummer, int zeile, int spalte, int wert){
  int i;

  for (i=0; i<6; i++) feld[feldnummer][zeile][i][wert]=' ';
  for (i=0; i<6; i++){
    if (i==wert) feld[feldnummer][zeile][spalte][i]=i+'0';
    else feld[feldnummer][zeile][spalte][i]=' ';}}

/*
 * Test, ob ein bestimmtes Feld gesetzt ist, also schon entdeckt
 * wurde.
 */
char gesetzt(int f, int zeile, int spalte){
  char ergebnis;
  int i, anzahl;

  ergebnis='\0';
  anzahl=0;
  for (i=0; i<6; i++){
    if (feld[f][zeile][spalte][i] != ' '){
      anzahl++;
      ergebnis=feld[f][zeile][spalte][i];}}
  if (anzahl > 1) return('\0');
  else return(ergebnis);}

/*
 * Die folgende Routine testet, ob das angegebene Bild am angegebenen
 * Ort gesetzt ist. Sie ist robust, was unsinnige Abfragen angeht.
 */
int sicher(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if ((spalte>-1) && (spalte<6)){
    if (gesetzt(1, zeile, spalte)==bild+'0') ergebnis=1;}
  return(ergebnis);}
   
/*
 * Suchen, in welcher Spalte, Zeile ist bekannt, ein bestimmtes Bild
 * gesetzt wurde. Das macht nur in Feld Nummer 0 Sinn.
 */
int suchspalte(int zeile, int bild){
  int ergebnis, i;

  ergebnis=-1;
  for (i=0; i<6; i++)
    if (feld[0][zeile][i][bild]==(char)(bild+'0')) ergebnis=i;
  return(ergebnis);}

/*
 * Das folgende Unterprogramm untersucht, ob unmittelbar rechts vn der
 * angegebenen Spalte in der angegebenen Zeile das angegebene Bild
 * moeglich ist.
 * Es wird auch dann `False' zurueckgegeben, wenn das Bild schon
 * gesetzt ist.
 */
int urechts(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte != 5){
    if (feld[1][zeile][spalte+1][bild]==bild+'0') ergebnis=1;}
    if (gesetzt(1, zeile, spalte+1)==bild+'0') ergebnis=0;
  return(ergebnis);}

/*
 * Das folgende Unterprogramm untersucht, ob unmittelbar links vn der
 * angegebenen Spalte in der angegebenen Zeile das angegebene Bild
 * moeglich ist.
 * Es wird auch dann `False' zurueckgegeben, wenn das Bild schon
 * gesetzt ist.
 */
int ulinks(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte != 0){
    if (feld[1][zeile][spalte-1][bild]==bild+'0') ergebnis=1;}
    if (gesetzt(1, zeile, spalte-1)==bild+'0') ergebnis=0;
  return(ergebnis);}

/*
 * Das folgende Unterprogramm testet, ob ein Bild unmittelbar rechts
 * von der angegebenen Spalte noch moeglich ist.
 */
int urechtsm(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte != 5){
    if (feld[1][zeile][spalte+1][bild]==bild+'0') ergebnis=1;}
  return(ergebnis);}

/*
 * Das folgende Unterprogramm testet, ob ein Bild unmittelbar links
 * von der angegebenen Spalte noch moeglich ist.
 */
int ulinksm(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte != 0){
    if (feld[1][zeile][spalte-1][bild]==bild+'0') ergebnis=1;}
  return(ergebnis);}

/*
 * Das folgende Unterprogramm testet, ob das angegebene Bild noch zwei
 * Felder rechts von der angegebenen Spalte noch moeglich ist.
 */
int zrechtsm(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte < 4){
    if (feld[1][zeile][spalte+2][bild]==bild+'0') ergebnis=1;}
  return(ergebnis);}

/*
 * Das folgende Unterprogramm testet, ob das angegebene Bild noch zwei
 * Felder links von der angegebenen Spalte existieren kann.
 */
int zlinksm(int zeile, int spalte, int bild){
  int ergebnis;

  ergebnis=0;
  if (spalte > 1){
    if (feld[1][zeile][spalte-2][bild]==bild+'0') ergebnis=1;}
  return(ergebnis);}

/*
 * Die folgende Routine testet, ob ein bestimmtes Bild in einer
 * angegebenen Zeile noch rechts von der angegebenen Spalte moeglich
 * ist.
 */
int rechtsm(int zeile, int spalte, int bild){
  int ergebnis, i;

  ergebnis=0;
  if (spalte < 5){
    for (i=spalte+1; i<6; i++){
      if (feld[1][zeile][i][bild]==bild+'0') ergebnis=1;}}
  return(ergebnis);}

/*
 * Die folgende Routine testet, ob links von der angegebenen Spalte
 * noch das angegebene Bild in der angegebenen Zeile vorkommen kann.
 */
int linksm(int zeile, int spalte, int bild){
  int ergebnis, i;

  ergebnis=0;
  if (spalte > 0){
    for (i=spalte-1; i>-1; i--){
      if (feld[1][zeile][i][bild]==bild+'0') ergebnis=1;}}
  return(ergebnis);}

/*
 * Die folgende Routine untersucht, ob ein Bild rechts von der
 * angegebenen Spalte noch einmal vorkommt. Es wird auch dann eine
 * Null zurueckgegeben, wenn das Bild schon gesetzt ist.
 */
int rechts(int zeile, int spalte, int bild){
  int ergebnis, anzahl, index, i;
  char c;

  ergebnis=0; anzahl=0; index=0;
  if (spalte < 5){
    for (i=spalte+1; i<6; i++){
      if (feld[1][zeile][i][bild]==bild+'0'){
        c=gesetzt(1, zeile, i);
	if (!c){
	  anzahl++;
	  index=i;}}}
    if (anzahl==1) ergebnis=index;}
  return(ergebnis);}

/* das folgende Unterprogramm untersucht, ob links von der angegebenen
 * Spalte das Bild genau noch einmal vorkommt. Es wird auch dann eine
 * MINUS EINS zurueckgegeben, wenn das entsprechende Bild schon
 * gesetzt ist.
 * Der Rueckgabewert unterscheidet sich von den anderen Routinen
 * dieser Art!!!
 */
int links(int zeile, int spalte, int bild){
  int ergebnis, anzahl, index, i;
  char c;

  ergebnis=-1; anzahl=0; index=-1;
  if (spalte > 0){
    for (i=spalte-1; i>-1; i--){
      if (feld[1][zeile][i][bild]==bild+'0'){
        c=gesetzt(1, zeile, i);
	if (!c){
	  anzahl++;
	  index=i;}}}
    if (anzahl==1) ergebnis=index;}
  return(ergebnis);}
/*
 * Die folgende Routine loescht alle ueberfluessigen Eintraege. Diese
 * koennen entstehen, wenn ein Bild dadurch gesetzt wird, dass es an
 * einer anderen Stelle nur noch alleine vorkommt. In diesem Falle
 * muessen alle anderen Vorkommen explizit geloescht werden.
 */
void loescheueberfluessiges(void){
  int z, s, b;
  char c;

  for (z=0; z<6; z++){
    for (s=0; s<6; s++){
      c=gesetzt(1, z, s);
      if (c){
        for (b=0; b<6; b++){
	  if (b != s) feld[1][z][b][c-'0']=' ';}}}}}

/*
 * Die folgende Routine gibt einen Zeiger auf einen String zurueck,
 * der eine passende Darstellung der Zeit beinhaltet.
 */
char *zeitdarstellung(void){
  int minuten, sekunden;

  minuten=(int)(zeit/60);
  sekunden=(int)(zeit % 60);
  sprintf(zeitstr,"Zeit: %d:%2d Minuten",minuten, sekunden);
  if (sekunden < 10)
  {
    if (minuten <10) zeitstr[8]='0';
    else zeitstr[9]='0';
  }
  return(zeitstr);}

