/****************************************************************
 *								*
 *				X-Mik                           *
 * 								*
 * Dies ist einen neue Version des Spiels Sherlock von der DOS- *
 * platform. Ich will mal wieder versuchen das Spiel unter	*
 * Linux zur Verfuegung zu stellen.				*
 *								*
 * F. Cremer 12.4.1999						*
 ****************************************************************/

#include	"xmik.h"

/*
 * Globale Variablen.
 * Im Falle dieses Spiels erscheint es mir sinnvoll, wenn einige
 * Variablen global angelegt werden. Vor allem das Spielfeld und sie
 * Variablen zum Zugriff auf die X-Routinen sollten global angelegt
 * sein.
 */

Display		*xdsp;		/* Zeiger auf den Display	*/
int		xsn;		/* Screennummer			*/
Colormap	xcm;		/* Colormap			*/
unsigned long	xbp, xwp;	/* Pixelwerte fuer Schwarz und	*/
				/* Weiss			*/
Window		xwin;		/* Das Window			*/
Window		xnf, xnj, xnn;	/* Die Nachfragewindows		*/
GC		xgc;		/* Graphischer Kontext		*/
XFontStruct	*xfi;		/* Fontstruktur			*/
XEvent		xev;		/* Eventstruktur		*/
Pixmap		xp1, xp2;	/* Pixmaps zum Kopieren		*/
Cursor		xc1, xc2, xc3;	/* Die Pointer			*/

char		loopflag;	/* Eventloopsteuerung		*/
char		befehl[BEFLEN];	/* Befehlspuffer		*/
char		hilfestr[BEFLEN]; /* Hilfepuffer		*/
char		hilfeflag;	/* Flag zur Anzeige		*/
char		feld[3][6][6][6]; /* Das Spielfeld		*/
				/* 0: Vorgabe			*/
				/* 1: Spielfeld			*/
char		bildname[2][6][6][50]; /* Die Namen der Bilder	*/
int		spielnummer;	/* Nummer des Spiels		*/
char		nurpos;		/* Flag fuer ausschl. pos. B.	*/

/* Die Hinweise werden in dieser Version anders bearbeitet, als in den
 * alten Versionen. Zum einen gibt es zwei Hinweisspeicher, damit die
 * Hinweise umgeschaltet werden koennen, zum anderen werden alle
 * Hinweise in einer Variablen abgelegt, damit sie von der
 * darstellenden Routine an einer Stelle gefunden werden koennen. Die
 * Nummern 0..17 dienen der Aufnahme der Hinweise mit zwei Eintraegen,
 * die von Nummer 18..38 denen, die drei Eintraege haben. Bei der
 * Erzeugung wird darauf geachtet, dass nicht zuviele Hinweise eines
 * Typs entstehen. Dafuer gibt es die Zaehlvariablen. Schliesslich
 * gibt es noch eine dritte Reihe von Hinweisen, damit nur die
 * Hinweise gezeichnet werden, die auch wirklich gezeichnet werden
 * muessen. */
struct tip	hinweis[3][39];	/* Enthaelt alle Hinweise	*/
int		hinschalter;	/* Schaltet zwischen den	*/
				/* Hinweisen um			*/
int		hinw1, hinw2;	/* Zaehler fuer Hinweise	*/
int		gesetzte;	/* Zaehler fuer gesetzte Bilder */
int		verschieben;	/* Merker fuers Verschieben	*/
int		drehen;		/* Merker fuers Drehen		*/

struct hist	root;		/* Der Beginn der Historie	*/

long int	zeit;		/* Zaehlt die Sekunden seit	*/
				/* Spielbeginn			*/
char		zeitstr[20];	/* Nimmt die Zeitdarstellung auf*/
struct itimerval t;		/* Steuerung des Timers		*/

/*
 * Deklaration der Unterprogramme
 */
extern void mydebug(char *text);
extern char xinitialisierung(int argc, char *argv[]);
extern void windowinhalt(void);
extern void zeichnefeld(int z, int s);
extern void buttonevent(XEvent xev);
extern void einleitung(int argc, char *argv[]);
extern void spielaufbau(void);
extern char interpretation(int feld, int argc);
extern void hilfe(void);
extern void history(void);
extern void delhist(void);
extern void undobefehl(void);
extern void wiederholung(void);
extern void bisfehler(void);
extern void hilfeanforderung(void);
extern void filedekrementieren(int argc);
extern void zeitansage(int dummy);
extern char *zeitdarstellung(void);
extern void information(void);
extern void feuerwerk(void);
extern void trauer(void);
extern char nachfrage(void);

/****************************************************************
 *								*
 *			    Hauptprogramm			*
 *								*
 * Im Hauptprogramm wird eigentlich nur die Struktur des Spiels *
 * festgelegt. Alle Routinen, die dan tatsaechlich etwas	*
 * machen, sind in eigenen Unterprogrammen und Unterprogramm-	*
 * bereichen untergebracht.					*
 *								*
 ****************************************************************/

void main(int argc, char *argv[]){

  char	xda;			/* Flag fuer das Ergebnis der
  				   X-Initialisierung		*/
  char	interergeb;		/* Ergebnis der Interpretation	*/
  char	spielloop;		/* Kontrolliert das Spiel	*/
  int	zeile, spalte;

  mydebug("main: Vor X-Initialisierung");
  xda=xinitialisierung(argc, argv);	/* Initialisierung des 
  					   X-Systems		*/
  mydebug("main: X-Initialisierung abgeschlossen");

  /* Vor der eigentlichen Hauptschleife muss der Timer initialisiert
   * werden. */
  signal(SIGALRM, &zeitansage);
  
  do{
    mydebug("main: Vor Einleitung des Spiels");
    einleitung(argc, argv);
    mydebug("main: Einleitung beendet, Spielaufbau beginnt");
    spielaufbau();
    mydebug("main: Spiel aufgebaut");
    XClearWindow(xdsp, xwin);
    windowinhalt();

    /* Nach dem Spielaufbau muss die Zeit neu gesetzt werden */
    zeit=0;
    information();
    
    mydebug("main: Spiel angezeigt");
    if (xda){
      printf("X-Mik\n"); printf("Version %s\n",VERSION);
    /* Einschalten des Timers */
    t.it_interval.tv_sec=0;
    t.it_interval.tv_usec=1000000;
    t.it_value.tv_sec=0;
    t.it_value.tv_usec=1000000;
    setitimer(ITIMER_REAL, &t, NULL);

    /* Nun beginnt der Eventloop und der Spielloop */
    loopflag=True; nurpos=True;
    mydebug("main: Beginn des Eventloops");
    do{
      XNextEvent(xdsp, &xev);
      befehl[0]='\0';
      switch (xev.type){
        case ConfigureNotify : break;
	case ButtonPress : {buttonevent(xev); break;}
	case ButtonRelease : {buttonevent(xev); break;}
	default : break;}
      if (befehl[0]){
	if (befehl[0]=='H') hilfeanforderung();
	else if (befehl[0]=='B') bisfehler();
	else if (befehl[0]=='F') undobefehl();
	else if (befehl[0]=='W') wiederholung();
	else{
	  if (befehl[0]=='-') nurpos=False;
	  interergeb=interpretation(1, argc);
	  if ((befehl[0]=='-') || (befehl[0]=='+')) history();}
	zeile=befehl[1]-'0';
	spalte=befehl[2]-'0';
	if ((befehl[0]=='+') || (befehl[0]=='-'))
	  for (spalte=0; spalte<6; spalte++) zeichnefeld(zeile, spalte);}
    } while (loopflag);
    mydebug("main: Eventloop beendet");

    /* Hier wird der Timer wieder ausgeschaltet */
    t.it_interval.tv_usec=0;
    t.it_value.tv_usec=0;
    setitimer(ITIMER_REAL, &t, NULL);

    if (befehl[strlen(befehl)-1] == 'R'){
      fprintf(stderr,"Herzlichen Glueckwunsch\n");
      fprintf(stderr,"Nummer %d erfolgreich geloest!\n",spielnummer);
      zeitdarstellung();
      fprintf(stderr,"%s\n",zeitstr);
      feuerwerk();
      information();}
    if (befehl[strlen(befehl)-1] == 'F'){
      filedekrementieren(argc);
      fprintf(stderr,"Leider falsch\n");
      trauer();}} /* Ende von: if (xda) */
    spielloop=nachfrage();}
  while (spielloop);
      
  /* Nun kommen die ganzen Aufraeumarbeiten */
  delhist();
  XFreeColormap(xdsp, xcm);
  XFreeGC(xdsp,xgc);
  XFreeCursor(xdsp, xc1);
  XFreeCursor(xdsp, xc2);
  XFreeCursor(xdsp, xc3);
  XFreeFont(xdsp, xfi);
  XUnmapWindow(xdsp, xwin);
  XCloseDisplay(xdsp);
} /* Ende des Hauptprogramms */

